/*
 * Description: This application tests the use of conditional variables to sync threads.
 * 
 * The WATERS19 app4mc example shows that, in case of GPU offloading (fake offloading), 
 * there must have two tasks. The first task, running in the Host side, does data preparation, 
 * input/output data copies. This first task is periodic.
 * The second task, running in the GPU side, does the computation itself. This task is blocked by the 1st one.
 * So, this example tests the sync mechanism used between these two tasks.
 * 
 * The 1st task uses InterProcessStimulus to call the 2nd task. Then the 1st is suspended until 
 * a signal (an OSEvent) comes from the 2nd task, indicating that the processing is done. 
 * 
 * This test will check whether two CPP conditional_variables can implement the same sync behavior.
 *  
 * This link https://tatourian.blog/2013/03/26/producer-consumer-inter-thread-communication-using-condition-variables-in-c/
 * helped to build this example.
 *
 * Author: 
 *  Alexandre Amory (November 2020), ReTiS Lab, Scuola Sant'Anna, Pisa, Italy.
 * 
 * Compilation: 
 *  $> g++ host_gpu_sync.cpp  -o host_gpu_sync  -lpthread
 *  
 * Usage Example: 
 *  $> ./host_gpu_sync
The 'HOST' is preparing the input data to the GPU ...
The GPU thread is blocked 
Data is done! Firing the GPU ...
The HOST is wating for the GPU to finish ...
The GPU thread is unblocked 
The GPU thread finished 
The HOST received a signal from the GPU
The 'HOST' is preparing the ouput data generated by the GPU ...
The HOST thread finished
the threads were joined...
 */

// condition_variable example
#include <iostream>           // std::cout
#include <thread>             // std::thread
#include <mutex>              // std::mutex, std::unique_lock
#include <condition_variable> // std::condition_variable

struct offloading_sync
{
  std::mutex mtx;
  std::condition_variable cvar;
  bool ready;

  offloading_sync(){
    this->ready = false;
  }
};

struct offloading_sync sync_start;
struct offloading_sync sync_end;

#define REPEATS 3

// this is imitating a GPU task, expecting to be unblocked by the HOST to
// do some super important computation
void gpu () {
  int iter=0;
  while(1){
    {
      std::cout << "The GPU thread ("<< iter << ") is blocked \n";
      std::unique_lock<std::mutex> lck(sync_start.mtx);
      while (!sync_start.ready){
        sync_start.cvar.wait(lck);
      }
      std::cout << "The GPU thread ("<< iter << ") is unblocked \n";
      // the 'GPU' is computing ...
      for (int i=0; i < 1000000000; i++);
      sync_start.ready = false;
    }

    // the GPU is done. Now, we are unblocking the HOST
    std::unique_lock<std::mutex> lck2(sync_end.mtx);
    sync_end.ready = true;
    sync_end.cvar.notify_all();    
    std::cout << "The GPU thread ("<< iter << ") finished \n";
    iter++;
  }
}

// this is imitating the HOST task that does some data adaptation and fires the GPU
void host() {
  int iter=0;
  // stays firing the GPU forever
  while(true){
    {
      std::unique_lock<std::mutex> lck(sync_start.mtx);
      std::cout << "The 'HOST' ("<< iter << ") is preparing the input data to the GPU ...\n";
      for (int i; i < 1000000; i++);
      sync_start.ready = true;
      std::cout << "Data is done! Firing the GPU ...\n";
      sync_start.cvar.notify_all();
    }

    // now master is blocked, waiting the GPU to unlock it
    std::unique_lock<std::mutex> lck2(sync_end.mtx);
    while (!sync_end.ready){
      sync_end.cvar.wait(lck2);
    }
    sync_end.ready = false;
    std::cout << "The HOST thread ("<< iter << ") is unblocked \n";
    std::cout << "The 'HOST' ("<< iter << ") is fixing the output data generated by the GPU ...\n";
    for (int i; i < 1000000; i++);
    std::cout << "The HOST thread ("<< iter << ") is finished \n\n\n";
    iter++;
  }
  // required to unblock the GPU for the last time
  std::unique_lock<std::mutex> lck(sync_start.mtx);
  sync_start.ready = true;
  sync_start.cvar.notify_all();
  
}

int main ()
{
  std::thread host_thread;
  std::thread gpu_thread;

  host_thread = std::thread(host);
  gpu_thread = std::thread(gpu);

  host_thread.join();
  gpu_thread.join();
  std::cout << "the threads were joined...\n";

  return 0;
}
